unit Flash8;

// http://help.adobe.com/en_US/FlashPlatform/reference/actionscript/2/index.html

interface
                 
type
  Number = Double;
  
  TMethod=procedure of object;

  BitmapData = external class(flash.display.BitmapData)
    constructor Create(Width, Height: Integer);
    procedure draw(Source: Object);
    property Smoothing: Boolean;
  end;
  
  Matrix = external class(flash.geom.Matrix)
    constructor Create;
    function clone: Matrix;
    function concat(m: Matrix): Matrix;
    procedure createBox(scaleX, scaleY, rotatio, tx, ty: Number);
  //function deltaTransformPoint(pt: Point): Point;
    procedure identity();
    procedure invert();
    procedure rotate(angle: Number);
    procedure scale(sx, sy: Number);
    function toString: string;
  //function transformPoint(pt: Point): Point;
    procedure translate(tx, ty: Number);
    property a: Number;
    property b: Number;
    property c: Number;
    property d: Number;
    property tx: Number;
    property ty: Number;
  end;
  
  Transform = external class(flash.geom.Transform)
//    property colorTransform: ColorTransform;
//    property concatenatedColorTransform: ColorTransform;
//    property concatenatedMatrix: Matrix;
    property matrix: Matrix;
//    property pixelBounds: Rectangle;
  end;
  
 MovieClip=external class
  constructor Create(Parent:MovieClip; Name:string; Depth:integer) as Parent.createEmptyMovieClip;
  function duplicateMovieClip(name: string; depth: Integer): MovieClip;
  procedure removeMovieClip();
  procedure loadMovie(url, Method: String);
  procedure getURL(url,window:string);
  procedure clear;
  procedure lineStyle(width,color:integer);
  procedure beginGradientFill(fillType:string; colors,alphas,ratios:array of integer; amatrix:TObject);
  procedure beginFill(color:integer);
  procedure beginBitmapFill(Bitmap: BitmapData; AMatrix: Matrix);
  procedure moveTo(x,y:double);
  procedure lineTo(x,y:double);
  procedure curveTo(x1,y1,x2,y2:double);
  procedure endFill();
  procedure setMask(mc: MovieClip);
  procedure swapDepths(target:double);
  function getDepth:integer;
  property blendMode: string;
  property _x:integer;
  property _y:integer;
  property _width:integer;
  property _height:integer;
  property _xscale:double;
  property _yscale:double;
  procedure startDrag(lockCentre:boolean; Left,Right,Top,Bottom:integer);
  procedure stopDrag();
  property _parent:MovieClip;
  property _name: string;
  property _visible: Boolean;
  property onPress:TMethod;
  property onRelease:TMethod;
  property onReleaseOutside:TMethod;
  property onEnterFrame:TMethod;
  property onMouseDown: TMethod;
  property onMouseUp: TMethod;
  property onMouseMove: TMethod;
  property _xmouse: Integer;
  property _ymouse: Integer;
  property _rotation: Double;
  property useHandCursor: Boolean;
  property transform: Transform;
 end;
 
 (*
 TOnLoadCompleteEvent = procedure(target_mc: MovieClip; HttpStatus: Integer) of object;
 TOnLoadErrorEvent = procedure(target_mc: MovieClip; ErrorCode: string; HttpStatus: Integer) of object;
 TOnLoadInitEvent = procedure(target_mc: MovieClip) of object;
 TOnLoadProgressEvent = procedure(target_mc: MovieClip; loadedBytes, totalBytes: Integer) of object;
 TOnLoadStartEvent = procedure(target_mc: MovieClip) of object;
 *)
 MovieClipLoader = external class
   constructor Create();
   function addListener(listener: Object): Boolean;
   function getProgress(target: Object): Object;
   function loadClip(url: string; target: Object): Boolean;
   function removeListener(listener: Object): Boolean;
   function unloadClip(target: Object): Boolean;
   property checkPolicyFile: Boolean;
  (*
   property onLoadComplete : TOnLoadCompleteEvent;
   property onLoadError : TOnLoadErrorEvent;
   property onLoadInit: TOnLoadInitEvent;
   property onLoadProgress: TOnLoadProgressEvent;
   property onLoadStart: TOnLoadStartEvent;
  *)
 end;

 TextFormat=external class
  constructor Create(const FontName:string; Size:integer);
  property align:string;
  property color:integer;
  property size:integer;
  property bold:boolean;
 end;

 TextField=external class
  constructor Create(Parent:MovieClip; Name:string; depth,left,top,width,height:integer) as Parent.createTextField;
  procedure setTextFormat(Format:TextFormat);
  procedure removeTextField;
  property embedFonts: Boolean;
  property text: string;
  property type: string;
  property background:boolean;
  property backgroundColor:integer;
  property _x: Integer;
  property _y: Integer;
 end;

 TMath=external class(Math)
//  function cos(a:double):double;
//  function sin(a:double):double;
  property PI:double;
 end;

 TKey = external class(Key)
   procedure addListener(listener: object);
   function removeListener(listener: object): Boolean;
   function getAscii: Integer;
   function getCode: Integer;
   function isAccessible: Boolean;
   function isDown(Code: Integer): Boolean;
   function isToggled(Code: Integer): Boolean;
   property capsLock: Boolean;
   property numLock: Boolean;
   property onKeyDown: TMethod;
   property onKeyUp: TMethod;
 end;
 
 Rectangle = external class
 end;
 
 TStage = external class(Stage)
   procedure addListener(listener: TObject);
   function removeListener(listener: TObject): Boolean;
   property align: string;
   property displayState: string;
   property fullScreenSourceRect: Rectangle;
   property height: Integer;
   property scaleMode: string;
   property showMenu: Boolean;
   property width: Integer;
 //onFullScreen = function(bFull: Boolean);
 //onResize = procedure;
 end;
 
 TSelection = external class(Selection)
   function setFocus(newFocus: TObject): Boolean;
 end;
 
 TXMLOnLoadEvent = procedure(success: Boolean) of object;
 
 
 XMLNode = external class
   property firstChild: XMLNode;
   property nodeName: string;
   property childNodes: array of XMLNode;
   property nextSibling: XMLNode;
   property attributes: TObject;//[Name: string]: string;
 end;
 
 XML = external class // (XMLNode)
   constructor Create;
   function load(url: string): Boolean;
   property ignoreWhite: Boolean;
   property onLoad: TXMLOnLoadEvent;
   property loaded: Boolean;
   property firstChild: XMLNode;
 end;

function cos(a:double):double external Math.cos;
function sin(a:double):double external Math.sin;
function random:double external Math.random;
function floor(a:double):integer external Math.floor;
function sqrt(a: Double): Double external Math.sqrt;
function atan2(x, y: Double):Double external Math.atan2;
function KeyDown(key:integer):boolean external Key.isDown;

const
 SHIFT=16;

var
 _root    : MovieClip; // static...
 Math     : TMath;
 Key      : TKey;
 Stage    : TStage;
 Selection: TSelection;

implementation

end.